package com.izouma.dingdong.web.backstage;

import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.backstage.Promote;
import com.izouma.dingdong.service.backstage.PromoteService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.backstage.PromoteRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/promote")
@AllArgsConstructor
public class PromoteController extends BaseController {
    private PromoteService promoteService;
    private PromoteRepo promoteRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Promote save(@RequestBody Promote record) {
        if (record.getId() != null) {
            Promote orig = promoteRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return promoteRepo.save(orig);
        }
        return promoteRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<Promote> all(PageQuery pageQuery) {
        return promoteRepo.findAll(toSpecification(pageQuery,Promote.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public Promote get(@PathVariable Long id) {
        return promoteRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        promoteRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Promote> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

